︠dcf03399-b6bd-481d-a0a6-84c8b8046ca6︠
#Original example: Credit goes to Josh Kantor
#http://sagemath.blogspot.com/2008/01/josh-kantors-lorenz-attractor-example.html
Integer = int
RealNumber = float

def lorenz(t,y,params):
    return [params[0]*(y[1]-y[0]),y[0]*(params[1]-y[2])- y[1],y[0]*y[1]-params[2]*y[2]]

def lorenz_jac(t,y,params):
    return [ [-params[0],params[0],0],[(params[1]-y[2]),-1,-y[0]],[y[1],y[0],-params[2]],[0,0,0]]

time_range=156
T=ode_solver()
T.algorithm="bsimp"
T.function=lorenz
T.jacobian=lorenz_jac
#T.ode_solve(y_0=[.5,.5,.5],t_span=[0, time_range-1],params=[10,6.5,3],num_points=10000)
#l=[T.solution[i][1] for i in range(len(T.solution))]

#line3d(l,thickness=0.3, viewer='jmol', figsize=8)
︡c1b41329-e55c-4581-95de-81cc5636b6fa︡︡
︠58d0ac74-6cc7-41eb-859d-f8cc494a6784︠
#9.3.3
#First a plot in x,y,z
#params=[10,22,8/3]
T.ode_solve(y_0=[.5,.5,.5],t_span=[0,155],params=[30,66,8],num_points=10000)
l=[T.solution[i][1] for i in range(len(T.solution))]
#for interactive image try viewer='jmol'
line3d(l,thickness=0.3, viewer='tachyon', figsize=8)
︡20932973-72dc-4356-8e4f-828adc658a46︡︡
︠b6b9fc01-7f36-4078-9ebe-50c91fec98ea︠
#calculate dimensions
xs=[T.solution[i][1][0] for i in range(len(T.solution))]
ys=[T.solution[i][1][1] for i in range(len(T.solution))]
zs=[T.solution[i][1][2] for i in range(len(T.solution))]
mins=(min(xs),min(ys),min(zs))
maxs=(max(xs),max(ys),max(zs))
print([mins,maxs])
︡7d2f4403-a875-40ba-bf47-e3e3273d409f︡{"stdout": "[(-48.402387945117837, -63.336232345397882, 0.40164579924863386), (50.941610214975526, 67.036089653494173, 114.31641467801353)]"}︡
︠b9b6b228-9378-40da-b005-ec90e084d5e9︠
xz = [(T.solution[i][1][0], T.solution[i][1][2]) for i in range(len(T.solution))]
line(xz)
︡aa53492d-ddcd-4a30-8189-3493e70221f0︡︡
︠710e9a23-4d5a-4ead-adad-c05599ef0b4c︠
xt = [((time_range-1)*i/len(T.solution), T.solution[i][1][0]) for i in range(len(T.solution))]
line(xt)
︡dd0ef984-6d5f-4c99-a19d-1e01b3698bf6︡︡
︠03768332-81f5-4b32-9eb3-cccc8aa5e004︠
yt = [((time_range-1)*i/len(T.solution), T.solution[i][1][1]) for i in range(len(T.solution))]
line(yt)
︡3828d398-3c9a-412a-93df-a0911cd6b2cf︡︡
︠0a49dba7-4792-4280-ba0f-1938ad1f5ae2︠
#9.3.5
T.ode_solve(y_0=[.5,.5,.5],t_span=[0,155],params=[10,100,8/3],num_points=10000)
l=[T.solution[i][1] for i in range(len(T.solution))]
#for interactive image try viewer='jmol'
line3d(l,thickness=0.3, viewer='tachyon', figsize=8)
︡b789874f-57e9-45db-8e72-5b639e0c772b︡︡
︠4eb5c436-1273-4bdd-a7a5-fdf1c1cd8c5c︠
xz = [(T.solution[i][1][0], T.solution[i][1][2]) for i in range(len(T.solution))]
line(xz)
︡4644ec9e-f14a-4749-a915-4bae2507d3e3︡︡
︠f49613c0-baeb-4eb6-bd8d-50669bad3822︠
xt = [((time_range-1)*i/len(T.solution), T.solution[i][1][0]) for i in range(len(T.solution))]
line(xt)
︡5874fc32-61b8-4917-b29a-08581ec92dec︡︡
︠531b462b-63b7-4d84-90c5-5158ae56d95d︠
yt = [((time_range-1)*i/len(T.solution), T.solution[i][1][1]) for i in range(len(T.solution))]
line(yt)
︡aaf9ad7a-fea3-44be-bfd1-b7973ce88d9f︡︡
